
set more off

clear

use "http://labs.fhcrc.org/pepe/book/data/wiedat2b.dta"

roccurve d y1 y2
roccurve d y1, tiecorr roc(0.2) pvcmeth(normal) nsamp(100)

roccurve d y1 y2, roc(0.2)   rocmeth(parametric) link(logit)       nograph
roccurve d y1,    roc(0.2)   rocmeth(parametric)                   nograph
roccurve d y1,    roc(0.05)  rocmeth(parametric) interval(0 .1 10) nograph

roccurve d y1, rocinv(0.8)
roccurve d y1, rocinv(0.8) rocmeth(parametric)
roccurve d y1, rocinv(0.8) pvcmeth(normal)
roccurve d y1, rocinv(0.8) pvcmeth(normal) rocmeth(parametric) 


roccurve d y1, adjcov(y2) adjmodel(linear) pvcmeth(normal) roc(0.05)

clear
* ### Ovarian Cancer dataset
use http://labs.fhcrc.org/pepe/book/data/ocdata_b
roccurve d y1 y2
roccurve d y1, tiecorr roc(0.2) pvcmeth(normal)
roccurve d y1, rocmeth(parametric) link(logit) roc(0.2)


clear
insheet y1 y2 d Z T W X C using "myData.csv", clear
rename z Z
rename t T
rename w W
rename x X
rename c C
gen dis=d
drop d

// A) One marker
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical)
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical)


// roc(0.05)
//rocmeth=nonparametric
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical) roc(.05) nsamp(100)
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal) roc(.05) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical) roc(.05) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal) roc(.05) nsamp(100)
//rocmeth=parametric
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical) roc(.05) rocmeth(parametric) nsamp(100)
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal) roc(.05) rocmeth(parametric) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical) roc(.05) rocmeth(parametric) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal) roc(.05) rocmeth(parametric) nsamp(100)


// rocinv(0.8)
// rocmeth=nonparametric
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical) rocinv(.8)  nsamp(100)
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal) rocinv(.8)  nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical) rocinv(.8) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal) rocinv(.8) nsamp(100)
// rocmeth=parametric
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal) rocinv(.8) rocmeth(parametric) nsamp(100)


/////////// B) Multiple...
clear
insheet d y1 y2 ds y1s y2s Zo Uo Wo y3 using "myDataBigger.csv", clear
rename zo Zo
rename wo Wo
rename uo Uo

//...markers
//roc(0.05)
 //rocmeth=nonparametric
roccurve d y1 y2, adjcov(Zo) adjmodel(stratified) pvcmeth(empirical) roc(.05) nsamp(100)
roccurve d y1 y2, adjcov(Zo) adjmodel(stratified) pvcmeth(normal) roc(.05) nsamp(100)
roccurve d y1 y2, adjcov(y3) adjmodel(linear) pvcmeth(empirical) roc(.05) nsamp(100)
roccurve d y1 y2, adjcov(y3) adjmodel(linear) pvcmeth(normal) roc(.05) nsamp(100)
 //rocmeth=parametric
roccurve d y1, adjcov(Zo) adjmodel(stratified) pvcmeth(empirical) rocmeth(parametric) roc(.1) nsamp(100)
roccurve d y1, adjcov(Zo) adjmodel(stratified) pvcmeth(normal) roc(.05) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(empirical) roc(.05) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(normal) roc(.05) rocmeth(parametric) nsamp(100)

// more adjustment covariates
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(empirical) roc(.05) nsamp(100)
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(normal) roc(.05) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(empirical) roc(.05) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(normal) roc(.05) nsamp(100)
#rocmeth=parametric
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(empirical) roc(.05) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(normal) roc(.05) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y2 y3) adjmodel(linear) pvcmeth(empirical) roc(.05) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y2 y3) adjmodel(linear) pvcmeth(normal) roc(.05) rocmeth(parametric) nsamp(100)


//rocinv(0.8)
 //rocmeth=nonparametric
roccurve d y1 y2, adjcov(Zo) adjmodel(stratified) pvcmeth(empirical) rocinv(.8) nsamp(100)
roccurve d y1 y2, adjcov(Zo) adjmodel(stratified) pvcmeth(normal) rocinv(.8) nsamp(100)
roccurve d y1 y2, adjcov(y3) adjmodel(linear) pvcmeth(empirical) rocinv(.8) nsamp(100)
roccurve d y1 y2, adjcov(y3) adjmodel(linear) pvcmeth(normal) rocinv(.8) nsamp(100)
 //rocmeth=parametric
roccurve d y1, adjcov(Zo) adjmodel(stratified) pvcmeth(empirical) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(Zo) adjmodel(stratified) pvcmeth(normal) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(empirical) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(normal) rocinv(.8) rocmeth(parametric) nsamp(100)

// more adjustment covariates
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(empirical) rocinv(.8) nsamp(100)
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(normal) rocinv(.8) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(empirical) rocinv(.8) nsamp(100)
roccurve d y1, adjcov(y3) adjmodel(linear) pvcmeth(normal) rocinv(.8) nsamp(100)
// rocmeth=parametric
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(empirical) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(Zo Uo) adjmodel(stratified) pvcmeth(normal) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y2 y3) adjmodel(linear) pvcmeth(empirical) rocinv(.8) rocmeth(parametric) nsamp(100)
roccurve d y1, adjcov(y2 y3) adjmodel(linear) pvcmeth(normal) rocinv(.8) rocmeth(parametric) nsamp(100)






clear 
use "http://labs.fhcrc.org/pepe/book/data/wiedat2b.dta"


comproc d y1, nsamp(100)
comproc d y1 y2, auc pauc(0.2) nsamp(100)
comproc d y1 y2, auc pauc(0.2) roc(0.2) rocinv(0.8) nsamp(100)
comproc d y1 y2, auc pauc(0.2) roc(0.2) rocinv(0.8) nsamp(100) pvcmeth(normal)

comproc d y1, nobstrap
comproc d y1, roc(0.2) rocinv(0.8) nobstrap
comproc d y1 y2, auc roc(0.2) nobstrap


clear
insheet y1 y2 d Z T W X C using "myData.csv", clear
rename z Z
rename t T
rename w W
rename x X
rename c C
gen dis=d
drop d

// A) One marker
comproc dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical)
comproc dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal)
comproc dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal)
comproc dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical)


// roc(0.05)
//rocmeth=nonparametric
comproc dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(empirical) roc(.05) nsamp(100)
comproc dis y1, adjcov(Z) adjmodel(stratified) pvcmeth(normal) roc(.05) nsamp(100)
comproc dis y1, adjcov(y2) adjmodel(linear) pvcmeth(empirical) roc(.05) nsamp(100)
comproc dis y1, adjcov(y2) adjmodel(linear) pvcmeth(normal) roc(.05) nsamp(100)


// cluster variable
comproc dis y1, cluster(C) adjmodel(stratified) pvcmeth(empirical) roc(.05) nsamp(100)
comproc dis y1, cluster(C) adjmodel(stratified) pvcmeth(normal) roc(.05)  nsamp(100)

comproc dis y1, noccsamp adjmodel(stratified) pvcmeth(empirical) roc(.05)  nsamp(100)
comproc dis y1, noccsamp adjmodel(stratified) pvcmeth(normal) roc(.05) nsamp(100)

comproc dis y1, noccsamp cluster(Z) adjmodel(stratified) pvcmeth(empirical) roc(.05) nsamp(100)
comproc dis y1, noccsamp cluster(Z) adjmodel(stratified) pvcmeth(normal) roc(.05)  nsamp(100)

